function paint()
{
	var val = box.getvalueof()[0]; // this is an array of size 1
	var myrounded = (box.getattr("rounded")); // get the rounded coeff.
	var viewsize = mgraphics.size;
	var width = viewsize[0];
	var height = viewsize[1];
	var start;

	mgraphics.set_source_rgba(box.getattr("bgcolor"));
	mgraphics.rectangle_rounded(0, 0, width, height, myrounded, myrounded);
	mgraphics.fill();
	

	
		// call original object paint method
	//mgraphics.parentpaint(); 
	
	var colorname = box.attrname_forstylemap("elementcolor");
	var bordercolor = box.getattr(colorname);
	
	// draw border rectangle over it 
	mgraphics.set_source_rgba(bordercolor);
	mgraphics.rectangle_rounded(0.5, 0.5, width-1, height-1, myrounded, myrounded);
	mgraphics.set_line_width(1.);
	mgraphics.stroke();
	
	var fontsize = box.getattr("fontsize");
	var fontstyle = box.getattr("fontface");
	var bold = fontstyle==1 || fontstyle==3 ? "bold" : 0;
	var italic = fontstyle==3 || fontstyle==3 ? "italic" : 0;
	var ascent;

	mgraphics.select_font_face(box.getattr("fontname"),italic,bold);
    mgraphics.set_font_size(box.getattr("fontsize"));
    ascent = mgraphics.font_extents()[0];
	
	
	
	var str;
	if (box.getattr("mode") == 1 && val)	// toggle mode on
		str = box.getattr("texton");
	else
		str = box.getattr("text");

	var size = mgraphics.text_measure(str);
	var fontmeasure = mgraphics.font_extents();

	mgraphics.move_to((width - size[0]) * 0.5, (height - size[1]) * 0.5 + size[1] - fontmeasure[1]);
	if (val)
		mgraphics.set_source_rgba(box.getattr("textoncolor"));
	else 
		mgraphics.set_source_rgba(box.getattr("textcolor"));
	
	mgraphics.show_text(str);


}