autowatch=1;
// set up inlets/outlets/assist strings
outlets = 1;

var mypatchsize = [100., 100.];
var mypatchposition = [0., 0.];
var myscreensize = [0, 0, 1920, 1200];
var mymainscreensize = [0, 0, 1920, 1200];
var mypatchzoom = 1.;
var mypatchstate = false;
var p = this.patcher;


function open_close()
{
		if (!this.patcher.wind.visible)
		{
   			p.front();
			window_create()
		}
		else	
		{
			p.wclose();
			outlet(0, "prefs", this.patcher.wind.location[0], this.patcher.wind.location[1], mypatchzoom);
		}
}

function open_patcher()
{
   		p.front();
}


function close_patcher()
{
		getlocation()
   		p.wclose();
   		outlet(0, "prefs", this.patcher.wind.location[0], this.patcher.wind.location[1], mypatchzoom);
}

function reset()
{
	   	p.wind.hashorizscroll = [false];
    	p.wind.hasvertscroll = [false];
	    p.wind.dirty = [false];
	    post("reset");
	    post();
}

		
function zoom(z)
{
		mypatchzoom = z
		outlet(0, "zoom", mypatchzoom);
		window_create()
}

function zoom_dec()
{
		mypatchzoom = (mypatchzoom - 0.1);
		outlet(0, "zoom", mypatchzoom);
		getlocation()
		window_create()
}

function zoom_inc()
{
		mypatchzoom = (mypatchzoom + 0.1);
		outlet(0, "zoom", mypatchzoom);
		getlocation()
		window_create()
}

function setlocation(x,y) 
	{
	mypatchposition = [x, y];
	window_create()
					//post("setlocation " + mypatchposition);
		//post();

    }

function window_create()
{

		if (isNaN(mypatchzoom)) mypatchzoom = 1.;
		
		
		//contrain le zoom en cas de besoin
	mypatchzoom = (mypatchzoom < 0.1) ? 0.1:mypatchzoom;
	mypatchzoom = (mypatchzoom > 2.9) ? 2.9:mypatchzoom;
	mypatchzoom = (mypatchzoom == 0.) ? 1.:mypatchzoom;
	
		//met les dimensions aux dimensions de l'écran en cas de besoin
	mypatchposition[0] = (mypatchposition[0] < myscreensize[0]) ? myscreensize[0]:mypatchposition[0];
	mypatchposition[0] = (mypatchposition[0] > myscreensize[2]) ? myscreensize[2]:mypatchposition[0];
	mypatchposition[1] = (mypatchposition[1] < myscreensize[1]) ? myscreensize[1]:mypatchposition[1];
	mypatchposition[1] = (mypatchposition[1] > myscreensize[3]) ? myscreensize[3]:mypatchposition[1];
	
		//Si la fenêtre se trouve dans l'écran principale, elle ne peut se trouver en haut
		//Il faut conserver les 45 pixel du menu
		if ((mypatchposition[0] >= mymainscreensize[0]) && (mypatchposition[0] <= mymainscreensize[2]) && (mypatchposition[1] >= mymainscreensize[1]) && (mypatchposition[1] <= mymainscreensize[3]))
			{				
				if (mypatchposition[1] < 45)
					{
					mypatchposition[1] = 45;
					}
			}
		
	

		if (this.patcher.wind.visible)
		{
		p.wind.location = [mypatchposition[0], mypatchposition[1], (mypatchposition[0] + (mypatchsize[0]* mypatchzoom)), (mypatchposition[1] + (mypatchsize[1]* mypatchzoom))];	
		p.zoomfactor(mypatchzoom);
		p.wind.exec;
		this.patcher.wind.scrollto(0,0);

		outlet(0, "prefs", this.patcher.wind.location[0], this.patcher.wind.location[1], mypatchzoom);	
		}
}

function getsize()
{
		if (this.patcher.wind.visible)
		mypatchsize = [this.patcher.wind.size[0], this.patcher.wind.size[1]]
		outlet(0, "size", this.patcher.wind.size[0], this.patcher.wind.size[1]);
}

function getlocation()
{
		if (this.patcher.wind.visible)
		{
		mypatchposition = [this.patcher.wind.location[0], this.patcher.wind.location[1]]
   		outlet(0, "prefs", this.patcher.wind.location[0], this.patcher.wind.location[1], mypatchzoom);
		}
}

function setsize(x,y) 
{
		mypatchsize = [x, y];
		if (this.patcher.wind.visible)
		{	
		mypatchposition = [this.patcher.wind.location[0], this.patcher.wind.location[1]]
		}
		window_create()
}

function setsize_x(x) 
{
		mypatchsize[0] = [x];
		if (this.patcher.wind.visible)	
		{
		mypatchposition = [this.patcher.wind.location[0], this.patcher.wind.location[1]]
		}
		window_create()
}

function setsize_y(y) 
{
		mypatchsize[1] = [y];
		if (this.patcher.wind.visible)	
		{
		mypatchposition = [this.patcher.wind.location[0], this.patcher.wind.location[1]]
		}
		window_create()
}



function setscreensize(x, y, a, b)
{
myscreensize = [x, y, (a - 20), (b-20)]
}

function setmainscreensize(x, y, a, b)
{
mymainscreensize = [x, y, (a - 20), (b-20)]
}

function patcher_prefs(x,y,z) 
{
	mypatchposition = [x, y];
	mypatchzoom = z;
}


function init_settings(){
p.wind.hasgrow = 0;
p.wind.haszoom = 0;
//p.wind.hashorizscroll = 0;
//p.wind.hasvertscroll = 0;
p.wind.exec;
}



function settitle(name){
p.wind.title = name
p.wind.exec;
}

function get_patcher_prefs(x,y,z) 
{
		if (this.patcher.wind.visible)
		{
		mypatchposition = [this.patcher.wind.location[0], this.patcher.wind.location[1]]
   		outlet(0, "patcher_prefs", this.patcher.wind.location[0], this.patcher.wind.location[1], mypatchzoom);
		}
}




//**************************************** Divers *****************************************
function dump()
{
	post ("The patcher size is : " + mypatchsize, "\n");
	post ("The patcher position is : " + mypatchposition, "\n");
	post ("The patcher zoom is : " + mypatchzoom, "\n");
	post ("The patcher state is : " + this.patcher.wind.visible, "\n");
}

function getvisible()
{	
	if (this.patcher.wind.visible) outlet(0, "visible", 1);
	if (!this.patcher.wind.visible) outlet(0, "visible", 0);
}


function getall()
{
		mypatchsize = [this.patcher.wind.size[0], this.patcher.wind.size[1]]
		mypatchposition = [this.patcher.wind.location[0], this.patcher.wind.location[1]]
		mypatchstate = [this.patcher.wind.visible]
		dump();
}


function resetscrollposition()
{
		this.patcher.wind.scrollto(0,0);
}
